/** editMachineOption.js
 * Methods required by editMachineOptions.xul.
 * @todo add enum version of this xul file for boolean typed options
 */

/** mtMachine, option name, and option type */
var g_machine, g_name, g_type;
/** Vars required to update caller */
var g_option_array, g_treeBoxObject;

function doEmoLoad() {
  if (window.arguments) {
    g_machine = window.arguments[0];
    g_name = window.arguments[1];
    g_option_array = window.arguments[2];
    g_treeBoxObject = window.arguments[3];
  }

//  alert("machine(" + g_machine + ") name(" + g_name + ")");

  g_type = g_machine.getOptionType(g_name);
  var value = getMachineOptionValue(g_machine, g_name);

  document.getElementById('option-name-text').value = g_name;
  document.getElementById('option-help-text').value = g_machine.getOptionHelp(g_name);

  var valueEl = document.getElementById('option-value');
  if (g_type == g_machine.OPT_TYPE_BOOL) {
    // deal with listbox
    
  } else {
    // deal with textbox
    valueEl.value = value;
  }

  valueEl.focus();
}

function doOK() {
//  alert("You pressed OK!");
  var valueEl = document.getElementById('option-value');
  if (valueEl.value == "") {
    alert("Please enter a legal option value");
    return false;
  }

  switch (g_type) {
  case g_machine.OPT_TYPE_INT:
    g_machine.setIOption(g_name, valueEl.value); break;
  case g_machine.OPT_TYPE_REAL:
    g_machine.setROption(g_name, valueEl.value); break;
  case g_machine.OPT_TYPE_BOOL:
    g_machine.setBOption(g_name, valueEl.value); break;
  }

  g_option_array[1] = valueEl.value;
  g_treeBoxObject.invalidate();

  return true;
}

function doCancel() {
//  alert("You pressed Cancel!");
  return true;
}
